import ProductData from "@comp/AppsComponent/ProductData/page";

async function getData(id) {
  const res = await fetch(`${process.env.NEXT_PUBLIC_API_URL}/product/${id}`);
  const post = await res.json();
  return post;
}

export async function generateMetadata({ params }) {
  const data = await getData(params.id[0]);

  const decodedName = decodeURIComponent(params.id[1]);
  const imageUrl = new URL(
    data?.product?.files && data?.product?.files[0]?.fileLocation,
    process.env.STORAGE_URL
  );

  const metadataUrl = new URL(
    `products/${params.id[0]}/${decodedName}`,
    process.env.NEXT_PUBLIC_APP_URL
  );
  return {
    title: decodedName,
    description: `  خرید ${decodedName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
    metadataBase: metadataUrl,
    product_id_meta: data?.product?.id,
    keywords: [
      "آرایشی",
      "بهداشت خانگی",
      "محصولات زیبایی",
      "لوازم تمیزی",
      "مراقبت شخصی",
    ],

    openGraph: {
      title: decodedName,
      description: `  خرید ${decodedName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
      images: [imageUrl],
      url: metadataUrl,
      type: "website",
      locale: "fa-IR",
      type: "website",
    },
    twitter: {
      site: "@vesmehstore",
      description: `  خرید ${decodedName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
      title: decodedName,
      creator: "@vesmehstore",
    },
    other: {
      product_id: data?.product?.id,
      product_name: data?.product?.persianName,
      product_price: data?.product?.costWithDiscount,
      product_old_price: data?.product?.cost,
      availability: data?.product?.stock > 0 ? "instock" : "outofstock",
      guarantee: "guarantee_sample",
    },
  };
}

const Page = async ({ params }) => {
  const data = await getData(params.id[0]);

  return (
    <>
      <ProductData params={params} data={data} />
    </>
  );
};

export default Page;
